var updates = {

    writeContent: function (xmlhttp) {
        if (!xmlhttp.responseText) {
            alert("I got nothing from the server");
            updates.formReset();
            return;
        }
        if (document.getElementById('result')) {
            var res = document.getElementById('result');
        } else {
            var res = document.createElement("div");
            res.id = 'result';
            document.forms[0].appendChild(res);
        }
        res.style.visibility = "visible";
        try {
            var data = eval('(' + xmlhttp.responseText + ')');
        } catch (e) {
          	alert('Couldn\'t evaluate. A syntax error?');
	      	updates.formReset();
    	  	return;
        }

		var error_obj;

        if (typeof data.error != "undefined") {
        	error_obj = data.error;
			data = [error_obj.message];  
        }
        var pre = document.createElement("pre");
        
        if (error_obj) {
			var pre = document.createElement("div");
			pre.style.color = 'red';        	
        } else {
        	var pre = document.createElement("pre");
        }
        
        var line = false;
        var br = false;
        var res = document.getElementById('result');
        res.innerHTML = '';
        for (var i in data) {
            line = document.createTextNode(data[i] + "\n");        
            pre.appendChild(line);
            br = document.createElement("br");
            pre.appendChild(br);
        }
        res.appendChild(pre);
        updates.formReset();
        
        if (error_obj &&
        	document.getElementById('hilite') && 
        	document.getElementById('hilite').firstChild &&
        	document.getElementById('hilite').firstChild.tagName == 'PRE') {

			var hilited_lines = document.getElementById('hilite').firstChild.innerHTML.split('\n');
			var new_hilite = '';
			for (var i = 0, max = hilited_lines.length; i < max; i++) {
				
				if ((i+1) == parseInt(error_obj.line)) {
					var regex = new RegExp('(' + error_obj.word + ')', 'ig');
					var new_line = hilited_lines[i].replace(
						regex, 
						'<span style="background: pink">$1</span>'
					);
					
					new_hilite += '<div style="background: yellow">';
					new_hilite += new_line;
					new_hilite += '</div>';
					
				} else {
					new_hilite += hilited_lines[i];
					new_hilite += '\n';
				}
				
			}
			document.getElementById('hilite').firstChild.innerHTML = new_hilite;			L

        }
        
		var attributes = {
    		backgroundColor: {from: '#D8E6FA', to: '#ffffff' }
		};
		var anim = new YAHOO.util.ColorAnim(res, attributes);
		anim.duration = 1;
		anim.animate();
    },
    
    formReset: function() {
        document.getElementById('submit').value = 'Evaluate';
        document.getElementById('submit').disabled = false;
    },
    
    hilite: function (xmlhttp) {
        if (document.getElementById('hilite')) {
            var hilite = document.getElementById('hilite');
        } else {
            var hilite = document.createElement("div");
            hilite.id = 'hilite';
            document.body.appendChild(hilite);
        }
        hilite.style.visibility = "visible";
        var data = eval(xmlhttp.responseText);

		var res = '';
		var keyword;
		for (var i in data) {
			
			keyword = data[i][1].split('\n');
			for (var j = 0, max = keyword.length; j < max; j++) {
			    if (keyword[j].length > 0) {
				    res += '<span class="hl-' + data[i][0] + '">';
				    res += keyword[j];
				    res += '</span>';
			    }
			    if (max > 1 && j < (max - 1)) {
			    	res += '\n';
			    }
				
			}
		}

		res = '<pre>' + res + '</pre>';
        hilite.innerHTML = res;
        
		var attributes = {
    		backgroundColor: {from: '#dceeff', to: '#ffffff' }
		};
		var anim = new YAHOO.util.ColorAnim(hilite, attributes);
		anim.duration = 1;
		anim.animate();

		
    }


}